/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vv.cxx,v $
 Language:  C++
 Date:      $Date: 2008/06/24 07:24:40 $
 Version:   $Revision: 1.4 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#include <qapplication.h>
#include <qpixmap.h>
#include <qsplashscreen.h>
#include <qtimer.h>

#include "vvMainWindow.h"

#include "vvVoxImageIO.h"
#include "vvVoxImageIOFactory.h"
#include "vvVfImageIO.h"
#include "vvVfImageIOFactory.h"

#include "itkImage.h"
#include "itkImageFileReader.h"
#include "itkByteSwapper.h"

#define IMAGE 20
#define DICOM 21
#define MERGED 22

int main( int argc, char** argv ) 
{
  itk::ImageIOFactory::RegisterBuiltInFactories();
  vv::VoxImageIOFactory::RegisterOneFactory();
  vv::VfImageIOFactory::RegisterOneFactory();
  std::vector<std::string> filenames;

  QApplication app( argc, argv );
  Q_INIT_RESOURCE(vvIcons);
  //QPixmap pixmap(":/splashscreen.PNG");
  QSplashScreen *splash = new QSplashScreen(QPixmap(QString::fromUtf8(":/new/prefix1/splashscreen.PNG")));
  /*splash->showMessage("VV 1.0 developped by Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr and CREATIS-LRMN http://www.creatis.insa-lyon.fr",(Qt::AlignRight | Qt::AlignBottom));*/
  splash->show();
  QTimer::singleShot(2000, splash, SLOT(close()));
  while(!splash->isHidden())
    app.processEvents();

  vvMainWindow window;
  window.show();

  if(argc >1)
    {
    for(int i = 1; i < argc; i++)
      {
      std::string temp = argv[i];
      filenames.push_back(temp);
      }
    window.LoadImages(filenames,IMAGE);
    }

 return app.exec();
}
