/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvIOCommon.cxx,v $
 Language:  C++
 Date:      $Date: 2008/04/10 06:59:37 $
 Version:   $Revision: 1.2 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef VVIOCOMMON_CXX
#define VVIOCOMMON_CXX


// vv include
#include "vvIOCommon.h"

//====================================================================
// Open a file for reading
void vv::openFileForReading(std::ifstream & is, const std::string & filename) {
  is.open(filename.c_str(), std::ios::in);
  if ( is.fail() ) {
	itkGenericExceptionMacro(<< "Could not open file (for reading): " << filename);
  }
}
//====================================================================
  
//====================================================================
// Open a file for writing
void vv::openFileForWriting(std::ofstream & os, const std::string & filename) {
  os.open(filename.c_str(), std::ios::out);
  if ( os.fail() ) {
	itkGenericExceptionMacro(<< "Could not open file (for writing): " << filename);
  }
}
//====================================================================

//====================================================================
// Read a dicom header  
gdcm::File * vv::readDicomHeader(const std::string & filename, const bool verbose) {
  if (verbose) {
	std::cout << "Reading DICOM <" << filename << ">" << std::endl;
  }
  gdcm::File *header = new gdcm::File();
  header->SetFileName(filename);
  header->SetMaxSizeLoadEntry(16384); // required ?
  header->Load();
  return header;
}
//====================================================================

#endif /* end #define VVIOCOMMON_CXX */

