/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvIOCommon.h,v $
 Language:  C++
 Date:      $Date: 2008/04/10 06:59:37 $
 Version:   $Revision: 1.2 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef VVIOCOMMON_H
#define VVIOCOMMON_H

// vv include
#include "vvCommon.h"

// itk & gdcm include
#include "itkMacro.h"
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
#include "gdcmFile.h"
#include "gdcmFileHelper.h"

namespace vv {
  
  //====================================================================
  // Open a File for reading/writing
  void openFileForReading(std::ifstream & is, const std::string & filename);
  void openFileForWriting(std::ofstream & os, const std::string & filename);

  //====================================================================
  // To short the code for reading an image
  template<typename ImageType>
  typename ImageType::Pointer readImage(const std::string & filename, const bool verbose=false);
  
   //====================================================================
   // To short the code for writing an image
  template<typename ImageType>
  void writeImage(const typename ImageType::Pointer image, 
 				  const std::string & filename, 
				  const bool verbose=false);
  
  //====================================================================
  // Read a dicom header  
  gdcm::File * readDicomHeader(const std::string & filename, const bool verbose=false);

#include "vvIOCommon.txx"

} // end namespace

#endif /* end #define VVIOCOMMON_H */

