/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvInfoPanelPlugin.cxx,v $
 Language:  C++
 Date:      $Date: 2008/06/11 12:54:20 $
 Version:   $Revision: 1.5 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef _vvInfoPanelPlugin_CXX
#define _vvInfoPanelPlugin_CXX

#include "vvInfoPanelPlugin.h"

#include <QtPlugin>
#include <iostream>

//====================================================================
vvInfoPanelPlugin::vvInfoPanelPlugin(QObject *parent) 
  : QObject(parent)  {
  initialized = false;
}
//====================================================================

//====================================================================
void vvInfoPanelPlugin::initialize(QDesignerFormEditorInterface * /* core */)  {
  if (initialized)
    return;
  initialized = true;
}
//====================================================================

//====================================================================
bool vvInfoPanelPlugin::isInitialized() const  {
  return initialized;
}
//====================================================================

//====================================================================
QWidget *vvInfoPanelPlugin::createWidget(QWidget *parent)  {
  return new vvInfoPanel(parent);
  //====================================================================
}

//====================================================================
QString vvInfoPanelPlugin::name() const  {
  return "vvInfoPanel";
}
//====================================================================

//====================================================================
QString vvInfoPanelPlugin::group() const  {
  return "Display Widgets [Examples]";
}
//====================================================================

//====================================================================
QIcon vvInfoPanelPlugin::icon() const {
  return QIcon();
}
//====================================================================

//====================================================================
QString vvInfoPanelPlugin::toolTip() const {
  return "";
}
//====================================================================

//====================================================================
QString vvInfoPanelPlugin::whatsThis() const {
  return "";
}
//====================================================================

//====================================================================
bool vvInfoPanelPlugin::isContainer() const {
  return false;
}
//====================================================================

//====================================================================
QString vvInfoPanelPlugin::domXml() const {
  return "<widget class=\"vvInfoPanel\" name=\"vvInfoPanel\">\n"
    "</widget>\n";
}
//====================================================================

//====================================================================
QString vvInfoPanelPlugin::includeFile() const {
  return "vvInfoPanel.h";
}
//====================================================================

Q_EXPORT_PLUGIN2(customwidgetplugin, vvInfoPanelPlugin)

#endif /* end #define _vvInfoPanelPlugin_CXX */

